'From Squeak3.7 of ''4 September 2004'' [latest update: #5989] on 5 December 2008 at 3:48:45 pm'!

!OldWorldState methodsFor: 'update cycle' stamp: 'jmv 12/5/2008 15:48'!
doOneCycleFor: aWorld
	"Do one cycle of the interaction loop. This method is called repeatedly when the world is running.

This is a moderately private method; a better alternative is usually either to wait for events or to check the state of things from #step methods."

	self interCyclePause: 
		((Preferences higherPerformance or: [Sensor eventQueue isEmpty not ]) 
			ifTrue: [ 1] 
			ifFalse: [MinCycleLapse]).
	self doOneCycleNowFor: aWorld.! !

