'From Cuis 1.0 of 4 September 2009 [latest update: #290] on 2 October 2009 at 10:03:19 am'!

!TextStyle methodsFor: 'initialization' stamp: 'jmv 9/28/2009 11:38'!
privateColor: aColor
	"To be used from TextStyle instance creation methods.
	If used on existing instances, existing text will be modified."
	
	color _ aColor.
	self class someStyleChanged! !

!TextStyle methodsFor: 'initialization' stamp: 'jmv 9/28/2009 11:38'!
privateFirstIndent: anInteger 
	"Set the horizontal indenting of the first line of a paragraph in the style 
	of the receiver to be the argument, anInteger."
	"To be used from TextStyle instance creation methods.
	If used on existing instances, existing text will be modified."

	firstIndent _ anInteger.
	self class someStyleChanged! !

!TextStyle methodsFor: 'initialization' stamp: 'jmv 9/28/2009 11:38'!
privateName: aString font: aFont
	"To be used from TextStyle instance creation methods.
	If used on existing instances, existing text will be modified."
	
	name _ aString.
	font _ aFont.
	alignment _ 0.
	tabsArray _ TextStyle defaultTabsArray.
	self class someStyleChanged! !

!TextStyle methodsFor: 'initialization' stamp: 'jmv 9/28/2009 11:38'!
privateName: aString font: aFont alignment: code
	"To be used from TextStyle instance creation methods.
	If used on existing instances, existing text will be modified."
	
	name _ aString.
	font _ aFont.
	alignment _ code.
	tabsArray _ TextStyle defaultTabsArray.
	self class someStyleChanged! !

!TextStyle methodsFor: 'initialization' stamp: 'jmv 9/28/2009 11:37'!
privateParagraphSpacingAfter: anInteger
	paragraphSpacingAfter _ anInteger.
	self class someStyleChanged! !

!TextStyle methodsFor: 'initialization' stamp: 'jmv 9/28/2009 11:38'!
privateParagraphSpacingBefore: anInteger
	paragraphSpacingBefore _ anInteger.
	self class someStyleChanged! !

!TextStyle methodsFor: 'initialization' stamp: 'jmv 9/28/2009 11:38'!
privateRestIndent: anInteger 
	"Set the indent for all but the first line of a paragraph in the style of the 
	receiver to be the argument, anInteger."
	"To be used from TextStyle instance creation methods.
	If used on existing instances, existing text will be modified."

	restIndent _ anInteger.
	self class someStyleChanged! !

!TextStyle methodsFor: 'initialization' stamp: 'jmv 9/28/2009 11:38'!
privateRightIndent: anInteger 
	"Set the right margin indent for the lines of a paragraph in the style 
	of the receiver to be the argument, anInteger."
	"To be used from TextStyle instance creation methods.
	If used on existing instances, existing text will be modified."

	rightIndent _ anInteger.
	self class someStyleChanged! !


!TextStyle class methodsFor: 'notifications' stamp: 'jmv 10/2/2009 10:03'!
someStyleChanged
	"Just a hook. Applications might use it to be notified of changes in a style, for example, to update editor windows"! !


!TextStyle class reorganize!
('class initialization' initialize)
('constants' defaultTab defaultTabsArray)
('instance creation' withFont: withFont:name:alignment:)
('user interface' modalStyleSelectorWithTitle:)
('instance accessing' availableTextStyleNames availableTextStyles default default: makeAvailable: named: removeNamed:)
('examples' createExamples)
('notifications' someStyleChanged)
!

